/***********************************************************************/
/*                                                                     */
/*                       ARCHIFOON                                     */
/*                                                                     */
/*                                                                     */
/*  De source van het programma is voornamelijk bedoeld voor           */
/*  nieuwsgierigen. Als je het programma hercompileert, breng          */
/*  het dan niet in omloop, maar neem even kontakt met mij op.         */
/*  Dit om te voorkomen dat er incompatibele versies ontstaan.         */
/*                                                                     */
/*  (C) Alle rechten voorbehouden, 29-2-1988, 25-3-1988.               */
/*                                                                     */
/*        Jeroen Fokker                                                */
/*        Kruislaan 17                                                 */
/*        3721 AL Bilthoven                                            */
/*        030--785610                                                  */
/*                                                                     */
/*                                                                     */
/***********************************************************************/




#define RES_NAME "ARCHI.RSC"
#include "tekst.h"      /* Nederlandse strings             */
#include "archi.h"      /* resource-items                  */
#include "naamnoot.h"   /* van naam-constante naar nummer  */
#include "nootnaam.h"   /* van nummer naar naam-string     */
#include "letnoot.h"    /* van keycode naar nummer         */
#include "sysvar.h"     /* globale gem-variabelen          */
#include "tabellen.h"
#include "archvar.h"    /* toestandsvariabelen en tabellen */
#include "ratio.h"      /* 12-tonige toonladders           */
#include "sysfun.h"
#include "diskio.h"     /* laden en saven van melodieen    */
overlay "record"
#include "record.h"     /* zorg voor opnemen en afdraaien  */
overlay "handel"
#include "handel.h"     /* afhandeling toets,button en menu*/
overlay "muziek"
#include "muziek.h"     /* muziek-basisroutines            */
overlay "stem"
#include "stem.h"
overlay "semant"
#include "semant.h"     /* afhandeling specif. menukeuzes  */
overlay "resinit"
#include "resinit.h"    /* laden RSC                       */
overlay "hoofd"

int init()
{
     if (! resinit()) return(FALSE);
     maaktoetsenbord();
     maakpiano();
     copyscreen( SCHERM, scherm );
     steminit();
     stem31();
     Supexec( klikuit );
     hndl_dial(dabout);
     return( TRUE );
}

term()
{  
     menu_bar( menu, FALSE);
     rsrc_free();
     v_clsvwk(handle);
     while (Bconstat(2)!=0) Bconin(2); /* empty typeahead-buffer */
     appl_exit();

}



main()
{
     if ( init()) multi();
     term();
}



