static char soundarray[]={0,0,1,0,7,255,8,15,11,0,12,84,13,3,255,0};

static char soundoffarray[]={7,255,8,0,9,0,10,0,255,0};

static int fijn[]={0,2,4};
static int grof[]={1,3,5};
static int volume[]={8,9,10};
static int mask[]={254,253,251};
static int volwaarde[3]={LEGATO,LEGATO,LEGATO}; 

maak31( nr, kanaal) int nr; int kanaal;
{
     noemnaam31( nr, kanaal);
     maaktoon( fr[nr], kanaal);
     if (record) voegtoe( nr, kanaal, nootlengte);
}

maak12( nr, kanaal) int nr; int kanaal;
{    
/* wordt alleen maar gebruikt in de 31-toonsstemming,
   wanneer de piano dus anomaliter nog 12-toons gestemd is.
   bovendien is dan ook record==false.
*/   
     noemnaam12( nr , kanaal);
     maaktoon( transpfact * tw[nr], kanaal);
}

maaktoon(fr,kanaal)  float fr; int kanaal;
{    
     int periode;
     periode = (125000/fr)+0.5;
     soundarray[0] = fijn[kanaal];
     soundarray[1] = (periode % 256);
     soundarray[2] = grof[kanaal];
     soundarray[3] = (periode / 256);
     aktief &= mask[kanaal];
     soundarray[5] = aktief;
     soundarray[6] = volume[kanaal];
     soundarray[7] = volwaarde[kanaal];
     Dosound(soundarray);
}

sound_off()
{     kanaal=0;
      aktief = 255;
      soundarray[5]=255;
      Dosound(soundoffarray);
      printf("%c%c%c%c                                                               ",27,'Y',32+9,34);
}

kanaal_off(i) int i;
{
     aktief |= (~mask[i]);
     soundarray[5] = aktief;
     soundarray[6] = volume[i];
     soundarray[7] = 0;
     Dosound(soundarray);
}

#define EMIT(x) info[i++]=x

int maaknoten( noot ) int *noot;
{    static char info[38];
     int i,s,oldaktief,periode,realprints;
     i=0;
     oldaktief = aktief;
     for (s=0;s<3;s++)
          switch( noot[s] )
          {    case -1:  break;
               case 0:   EMIT( volume[s] );
                         EMIT( 0 );
                         aktief |= (~mask[s]);
                         break;
               default:  periode = (125000/fr[noot[s]])+0.5;
                         EMIT( fijn[s] );
                         EMIT( periode % 256 );
                         EMIT( grof[s] );
                         EMIT( periode / 256 );
                         if ( (aktief&(~mask[s])) != 0 )
                         {    EMIT( volume[s] );
                              EMIT( LEGATO );
                              aktief &= mask[s];
                         }
                         /*noemnaam31(noot[s],s);realprints++;*/
          }
     if (aktief != oldaktief)
     {    EMIT( 7 );
          EMIT( aktief );
     }
     EMIT( 255 );
     EMIT( 0 );
     Dosound( info );
     realprints = 0;
     for (s=0;s<3;s++)
          if(noot[s]>0)
          {    noemnaam31(noot[s],s);
               realprints++;
          }        
     return(realprints);
}


plof()
{
     static char plofsound[]={6,31,7,0x2F,9,16,12,32,13,0,0xFF,0};
     Dosound(plofsound);
}


noemnaam31(noot,kanaal) int noot, kanaal;
{     
      
       printf("%c%c%c%c%4s  (%6.2f Hz) \n"
             ,27, 'Y', 32+9, 34+kanaal*20
             ,nootnaam[noot%31]
             ,fr[ noot ]
             );
}


noemnaam12(noot,kanaal) int noot, kanaal;
{    
 printf("%c%c%c%c%4s  (%6.2f Hz) \n"
       ,27, 'Y', 32+9, 34+kanaal*20
       ,nootnaam[mappiano[0][noot%12]]
       , transpfact*tw[ noot ]
       );
}

wacht(n) int  n;
{
     int x,y,u;
     u = (int)((600.0/tempo)*n);
     for (y=0;y<100;y++) for (x=0;x<u;x++);    /* wachtlus */
     
}


doosje( x0, y0, kl)   int x0,y0,kl;
{
     mbox(x0,y0,TB,-TB,TRUE,(kl==0?0:kl+1));    
}


maaktoetsenbord()
{    int x,y,rij,kol,aantkol;
     MUISUIT;
     vsf_interior(handle,2);
     vsf_perimeter(handle,1);
     vsf_color(handle,1);
     y=400-BM;
     for  (rij=0; rij<TBH; rij++)
     {    x=LM+1;
          aantkol=TBB;
          if   ((rij%2)==0)
          {    x+=HTR;
               aantkol-=1;
          };
          for  (kol=0; kol<aantkol; kol++)
          {    doosje( x+TS, y-TS, toetskleur[rij][kol] );
               x+=TR;
          };
          y-=TR;
     }
     MUISAAN;
}

toets( x0, y0, kl) int x0, y0, kl;
{
     int ar[10];
     int breedte, hoogte;
     if (kl==0)
     {    vsf_interior(handle,0);
          breedte = 24;
          hoogte = 90;
     }
     else{vsf_interior(handle,2);
          vsf_style(handle,8);
          breedte=12;
          hoogte =60;
     }
     ar[0] = x0;
     ar[1] = y0;
     ar[2] = x0+breedte;
     ar[3] = y0;
     ar[4] = x0+breedte;
     ar[5] = y0-hoogte;
     ar[6] = x0;
     ar[7] = y0-hoogte;
     ar[8] = x0;
     ar[9] = y0;
     v_fillarea(handle, 5, ar);
}

maakpiano()
{
     int x,i;
     MUISUIT;
     /* witte toetsen: */
     x=32;
     for (i=0; i<24; i++)
     {    toets(x,120,0);
          x+=24;
     }
     /* zwarte toetsen: */
     x=50;
     for (i=0; i<23; i++)
     {    if ( i!=2 && i!=6 && i!=9 && i!=13 && i!=16 && i!=20)
               toets(x,90,1);
          x+=24;
     }
     MUISAAN;
}

int map12to31( n ) int n;
{    int oktaaf,temp;
     oktaaf = n/12;
     switch(gestemd)
     {    case MPYTH:   temp = 1; break;
          case MMIDDEN: temp = 2; break;
          case MEULER:  temp = 3; break;
          case MUSER:   temp = 4; break;
          default:      temp = 0;
     }
     return ( 31*oktaaf + mappiano[temp][n%12] );
}

int map31to12( n ) int n;
{
     int oktaaf;
     oktaaf = n/31;
     return( 12*oktaaf + map3112[n%31] );
}

